<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Sep 4, 2013 10:33:00 AM
 * @version $Rev$
 */

/**
 * Login class
 * Used to ....
 */
class Entity_Form_Login {

  private $interfacer = null;
  private $required_fields = array(
    'email', 'password'
  );

  public function __construct() {
    $this->interfacer = WP_Interfacer::getInstance();
  }

  public function display($fromWidget = FALSE) {
  	$html_output = "";

    $backtrace = debug_backtrace();
    foreach ($backtrace as $bkt) {
      if (isset($bkt['file'])) {
        if (basename($bkt['file']) == 'class-frontend.php')
          return $html_output;
      }
    }

    if (isset($_GET['forgot']) && $_GET['forgot'] == 'true') {
      $forgot_form = new Entity_Form_ForgotPassword();
      $html_output .= $forgot_form->display();
      return $html_output;
    }

    $data = array();
    $errors = array();
    $general_error = '';
    $input_data = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
    $labels = Utils_Labels::get();


    if ($input_data !== NULL && isset($input_data['login_action']) && wp_verify_nonce($input_data['_carerix_nonce_field'], 'login')) {
		foreach ($this->required_fields as $field) {
			if (!isset($input_data[$field]) || strlen(trim($input_data[$field])) == 0) {
			  $errors[$field] = $labels['CxPortal.message.mandatory.mandatory'];
			}
		}

	    if (count($errors) == 0) {
        $general_exception = false;
        $exe = false;
        $employee = null;

        try {
          $email = trim($input_data['email']);
          $password = trim($input_data['password']);

          $params = array(
            'userName' => $email,
            'password' => $password,
          );

          $employee = Carerix_Api_Rest_Entity_CREmployee::getBy($params);
        } catch (Carerix_Api_Rest_Exception $care) {
          if ($employee == null) {

            $employees = Carerix_Api_Rest_Entity_CREmployee::findAll(array(
                  'show' => array('firstName', 'lastNamePrefix', 'lastName', 'employeeID', 'toUser.emailAddresses.emailAddress', 'toUser.password'),
                  'qualifier' => "toUser.emailAddresses.emailAddress = '$email' and toUser.password = '$password'"
            ));

            foreach ($employees as $emp) {
              $employee = $emp;
              break;
            }
          }

          if ($employee == null) {
            $general_error = $care->getMessage();
            $general_exception = $care;
            $exe = true;
          }
        } catch (Exception $ex) {
          $general_error = $ex->getMessage();
          $general_exception = $ex;
          $exe = true;
        }
        if ($general_exception || $exe) {
          // [todo] make pretty error
          if (!@$employee)
            $employee = false;
          Utils_Log::write(Utils_Log::TYPE_FETCH_EMPLOYEE, $employee, $general_exception);
        }

        if (!$exe && $employee != null) {
	      \Carerix\Cookie\Cookie::setCookie("logged_in", true);
	      \Carerix\Cookie\Cookie::setCookie("name", @$employee->firstName
              . ' ' . @$employee->lastNamePrefix
              . ' ' . @$employee->lastName);
	      \Carerix\Cookie\Cookie::setCookie("employee_id", @$employee->employeeID);

          $data['succesful'] = true;
        } else {
          $general_error = $labels['CxPortal.message.error.login'];
        }
      }
    }

    $data['errors'] = $errors;
    $data['general_error'] = $general_error;
    $data['back'] = $this->interfacer->get_post_permalink();
    $data['fromwidget'] = $fromWidget;

    $template = new Utils_Template('frontend/forms/login');
    $output = $template->with($data)->display( true );

	$html_output .= $output;
	return $html_output;
  }

}
