<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Aug 29, 2013 9:29:42 AM
 * @version $Rev$
 */

/**
 * Job class
 * Used to ....
 */
class Entity_Writer_Promotional extends Entity_Writer {
	
	protected $type = WP_Constants::ENTITY_TYPE_PROMOTIONAL;
	protected $postType = 'page';

	protected $sections = array(
		'introInformation', 'companyInformation', 'vacancyInformation',
		'requirementsInformation', 'offerInformation', 'functionContactInformation',
		'applicationContactInformation', 'publicationEnd',
	);
	
	protected $labelKeysForSection = array(
		'introInformation' => 'CxPortal.message.field.introduction',
		'companyInformation' => 'CxPortal.message.field.organization',
		'vacancyInformation' => 'CxPortal.message.field.function',
		'requirementsInformation' => 'CxPortal.message.field.requirements',
		'offerInformation' => 'CxPortal.message.field.offer',
		'functionContactInformation' => 'CxPortal.message.field.information',
		'applicationContactInformation' => 'CxPortal.message.field.application',
		'publicationEnd' => 'CxPortal.message.field.closingDate',
	);
    
    protected $introText = '';


    public function setIntroText($introText) {
        $this->introText = $introText;
    }

	public function getContent() 
	{
		$labels = Utils_Labels::get();
		$content = '';
		
		$set = false;
		
		foreach($this->sections as $section)
		{
			if(isset($this->dataDictionary[$section]))
			{
				
				$label_key = $this->labelKeysForSection[$section];
				$section_name = $labels[$label_key];
			
				
				$content .= "<h4 class='cx_h4'>$section_name</h4><p>{$this->dataDictionary[$section]}</p> ";
			}
			
			if(!$set)
			{
				$content .= '<!--more-->';
				$set = true;
			}
		}
		
		return $content;
	}

	public function getTitle() 
	{
		if(isset($this->dataDictionary['titleInformation']))
		{
			return $this->dataDictionary['titleInformation'];
		}
		
		if(isset($this->dataDictionary['toVacancy.jobTitle']))
		{
			return $this->dataDictionary['toVacancy.jobTitle'];
		}
		
		return '';
	}
	
	public function getCorrespondentID()
	{
		if(isset($this->dataDictionary['publicationID']))
		{
			return $this->dataDictionary['publicationID'];
		}
		
		return false;
	}
	
	public function getPublishDate()
	{
		if(isset($this->dataDictionary['publicationStart']))
		{
			return $this->dataDictionary['publicationStart'];
		}
		
		return false;
	}

    public function getSlug() {
        return false;
    }
}